# azure.mgmt.iothub.models module

class `azure.mgmt.iothub.models.``SharedAccessSignatureAuthorizationRule`(key_name=None, primary_key=None, secondary_key=None, rights=None)

  Bases: `msrest.serialization.Model`

  The properties that describe the keys to access the IotHub artifacts.

  Parameters:

  - key_name (str) – The name of the key.
  - primary_key (str) – The primary key.
  - secondary_key (str) – The secondary key.
  - rights (str or `AccessRights`) – The access rights. Possible values include: ‘RegistryRead’, ‘RegistryWrite’, ‘ServiceConnect’, ‘DeviceConnect’, ‘RegistryRead, RegistryWrite’, ‘RegistryRead, ServiceConnect’, ‘RegistryRead, DeviceConnect’, ‘RegistryWrite, ServiceConnect’, ‘RegistryWrite, DeviceConnect’, ‘ServiceConnect, DeviceConnect’, ‘RegistryRead, RegistryWrite, ServiceConnect’, ‘RegistryRead, RegistryWrite, DeviceConnect’, ‘RegistryRead, ServiceConnect, DeviceConnect’, ‘RegistryWrite, ServiceConnect, DeviceConnect’, ‘RegistryRead, RegistryWrite, ServiceConnect, DeviceConnect’

class `azure.mgmt.iothub.models.``IotHubProperties`(authorization_policies=None, host_name=None, event_hub_endpoints=None, storage_endpoints=None, messaging_endpoints=None, enable_file_upload_notifications=None, cloud_to_device=None, comments=None, operations_monitoring_properties=None, features=None)

  Bases: `msrest.serialization.Model`

  The Iot Hub properties.

  Parameters:

  - authorization_policies (list of `SharedAccessSignatureAuthorizationRule`) – The authorization rules.
  - host_name (str) – The name of the host.
  - event_hub_endpoints (dict) – The event hub endpoint properties.
  - storage_endpoints (dict) – The list of storage end points where files can be uploaded. Currently only one storage account can be configured.
  - messaging_endpoints (dict) – The list of messaging end points configured.
  - enable_file_upload_notifications (bool) – The flag which indicates whether file upload notification should be enabled. This is optional at iot hub level. When enabled upload notifications will be available.
  - cloud_to_device (`CloudToDeviceProperties`) –
  - comments (str) – The comments.
  - operations_monitoring_properties (`OperationsMonitoringProperties`) –
  - features (str or `Capabilities`) – The Capabilities/Features that need to be enabled for the Hub. Possible values include: ‘None’, ‘DeviceManagement’

class `azure.mgmt.iothub.models.``EventHubProperties`(retention_time_in_days=None, partition_count=None, partition_ids=None, path=None, endpoint=None, internal_authorization_policies=None, authorization_policies=None)

  Bases: `msrest.serialization.Model`

  The properties of the provisioned event hub used by the Iot Hub.

  Parameters:

  - retention_time_in_days (long) – The retention time in days. Range of values [For F1: 1-1, S1: 1-7, S2: 1-7, S3: 1-7].
  - partition_count (int) – The partition count. Range of values [For F1: 2-2, S1: 2-128, S2: 2-128, S3: 2-128].
  - partition_ids (list of str) – The partition ids.
  - path (str) – The eventhub path.
  - endpoint (str) – The endpoint.
  - internal_authorization_policies (list of `SharedAccessAuthorizationRule`) – The internal authorization rules.
  - authorization_policies (list of `SharedAccessAuthorizationRule`) – The authorization rules.

class `azure.mgmt.iothub.models.``SharedAccessAuthorizationRule`(key_name=None, primary_key=None, issuer_name=None, secondary_key=None, claim_type=None, claim_value=None, rights=None, created_time=None, modified_time=None, revision=None)

  Bases: `msrest.serialization.Model`

  SharedAccessAuthorizationRule.

  Parameters:

  - key_name (str) – The key name.
  - primary_key (str) – The primary key.
  - issuer_name (str) – The issuer name.
  - secondary_key (str) – The secondary key.
  - claim_type (str) – The claim type.
  - claim_value (str) – The claim value.
  - rights (list of str or `SBAccessRights`) – The rights.
  - created_time (datetime) – The created time.
  - modified_time (datetime) – The modified time.
  - revision (long) – The revision.

class `azure.mgmt.iothub.models.``StorageEndpointProperties`(sas_ttl_as_iso8601=None, connection_string=None, container_name=None)

  Bases: `msrest.serialization.Model`

  The properties of the Storage Endpoint for file upload.

  Parameters:

  - sas_ttl_as_iso8601 (timedelta) – SAS time to live. Range: 1 Min (PT1M) - 1 Day (P1D).
  - connection_string (str) – The account key credentials for storage account selected by customer for uploading files.
  - container_name (str) – The root container name where all files will be uploaded.

class `azure.mgmt.iothub.models.``MessagingEndpointProperties`(lock_duration_as_iso8601=None, ttl_as_iso8601=None, max_delivery_count=None)

  Bases: `msrest.serialization.Model`

  The properties of the Messaging Endpoints used by this IoT Hub.

  Parameters:

  - lock_duration_as_iso8601 (timedelta) – The lock duration. Range: 5 Sec (PT5S) - 5 Min (PT5M).
  - ttl_as_iso8601 (timedelta) – The time to live. Range: 1 Min (PT1M) - 2 Days (P2D).
  - max_delivery_count (int) – The max delivery count. Range: 1-100.

class `azure.mgmt.iothub.models.``CloudToDeviceProperties`(max_delivery_count=None, default_ttl_as_iso8601=None, feedback=None)

  Bases: `msrest.serialization.Model`

  The Iot Hub Cloud-To-Device messaging properties.

  Parameters:

  - max_delivery_count (int) – The max delivery count for the device queue. Range : 1-100.
  - default_ttl_as_iso8601 (timedelta) – The default time to live for the device queue. Range : 1 Min (PT1M) - 2 Days (P2D).
  - feedback (`FeedbackProperties`) –

class `azure.mgmt.iothub.models.``FeedbackProperties`(lock_duration_as_iso8601=None, ttl_as_iso8601=None, max_delivery_count=None)

  Bases: `msrest.serialization.Model`

  The Feedback Queue properties.

  Parameters:

  - lock_duration_as_iso8601 (timedelta) – The lock duration for the feedback queue. Range: 5 Sec (PT5S) - 5 Min (PT5M).
  - ttl_as_iso8601 (timedelta) – The time to live for the feedback queue. Range: 1 Min (PT1M) - 2 Days (P2D).
  - max_delivery_count (int) – The max delivery count. Range : 1-100.

class `azure.mgmt.iothub.models.``OperationsMonitoringProperties`(events=None)

  Bases: `msrest.serialization.Model`

  The Operation Monitoring properties.

  Parameters: | events (dict) –

class `azure.mgmt.iothub.models.``IotHubSkuInfo`(name=None, capacity=None)

  Bases: `msrest.serialization.Model`

  The Sku related information for the hub.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - name (str or `IotHubSku`) – The name of the Sku. Possible values include: ‘F1’, ‘S1’, ‘S2’, ‘S3’
  - capacity (long) – The number of units being provisioned. Range of values [For F1: 1-1, S1: 1-200, S2: 1-200, S3: 1-10]. To go above this range, call support.

  Variables: | tier (str or `IotHubSkuTier`) – The tier. Possible values include: ‘Free’, ‘Standard’

class `azure.mgmt.iothub.models.``IotHubDescription`(location=None, tags=None, subscriptionid=None, resourcegroup=None, etag=None, properties=None, sku=None)

  Bases: `azure.mgmt.iothub.models.resource.Resource`

  The description of the IotHub.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The Resource Id.
  - name (str) – The Resource name.
  - type (str) – The Resource type.

  Parameters:

  - location (str) – The Resource location.
  - tags (dict) – The Resource tags.
  - subscriptionid (str) – The subscription identifier.
  - resourcegroup (str) – The resource group name uniquely identifies the resource group within the user subscriptionId.
  - etag (str) – The Etag field is not required. If it is provided in the response body, it must also be provided as a header per the normal ETag convention.
  - properties (`IotHubProperties`) –
  - sku (`IotHubSkuInfo`) –

class `azure.mgmt.iothub.models.``Resource`(location=None, tags=None)

  Bases: `msrest.serialization.Model`

  Resource.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – The Resource Id.
  - name (str) – The Resource name.
  - type (str) – The Resource type.

  Parameters:

  - location (str) – The Resource location.
  - tags (dict) – The Resource tags.

class `azure.mgmt.iothub.models.``ErrorDetails`(code=None, message=None, details=None)

  Bases: `msrest.serialization.Model`

  The properties related to the details of an error.

  Variables are only populated by the server, and will be ignored when sending a request.

  Parameters:

  - code (str) – The error code.
  - message (str) – The error message.
  - details (str) – The error details.

  Variables: | http_status_code (str) – The http status code.

exception `azure.mgmt.iothub.models.``ErrorDetailsException`(deserialize, response, *args)

  Bases: `msrest.exceptions.HttpOperationError`

  Server responsed with exception of type: ‘ErrorDetails’.

  Parameters:

  - deserialize – A deserializer
  - response – Server response to be deserialized.

class `azure.mgmt.iothub.models.``IotHubQuotaMetricInfo`(name=None, current_value=None, max_value=None)

  Bases: `msrest.serialization.Model`

  The properties related to quota metrics.

  Parameters:

  - name (str) – The name of the quota metric.
  - current_value (long) – The current value for the quota metric.
  - max_value (long) – The maximum value of the quota metric.

class `azure.mgmt.iothub.models.``RegistryStatistics`(total_device_count=None, enabled_device_count=None, disabled_device_count=None)

  Bases: `msrest.serialization.Model`

  The properties related to the registry statistics.

  Parameters:

  - total_device_count (long) – The total device count.
  - enabled_device_count (long) – The enabled device count.
  - disabled_device_count (long) – The disabled device count.

class `azure.mgmt.iothub.models.``JobResponse`(job_id=None, start_time_utc=None, end_time_utc=None, type=None, status=None, failure_reason=None, status_message=None, device_id=None, parent_job_id=None)

  Bases: `msrest.serialization.Model`

  The properties describing a Job Response.

  Parameters:

  - job_id (str) – The job identifier.
  - start_time_utc (datetime) – Start time of the Job.
  - end_time_utc (datetime) – Represents the time the job stopped processing.
  - type (str or `JobType`) – The type of job to execute. Possible values include: ‘unknown’, ‘export’, ‘import’, ‘backup’, ‘readDeviceProperties’, ‘writeDeviceProperties’, ‘updateDeviceConfiguration’, ‘rebootDevice’, ‘factoryResetDevice’, ‘firmwareUpdate’
  - status (str or `JobStatus`) – Status of the Job. Possible values include: ‘unknown’, ‘enqueued’, ‘running’, ‘completed’, ‘failed’, ‘cancelled’
  - failure_reason (str) – If status == failure, this represents a string containing the reason.
  - status_message (str) – The status message for the job.
  - device_id (str) – The deviceId related to this response.
  - parent_job_id (str) – The jobId of the parent job, if any.

class `azure.mgmt.iothub.models.``IotHubSkuDescription`(sku=None, capacity=None)

  Bases: `msrest.serialization.Model`

  The properties related to the Sku.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables: | resource_type (str) – The type of the resource.

  Parameters:

  - sku (`IotHubSkuInfo`) –
  - capacity (`IotHubCapacity`) –

class `azure.mgmt.iothub.models.``IotHubCapacity`(minimum=None, maximum=None, default=None, scale_type=None)

  Bases: `msrest.serialization.Model`

  The properties related to the capacity information.

  Parameters:

  - minimum (long) – The minimum number of units.
  - maximum (long) – The maximum number of units.
  - default (long) – The default number of units.
  - scale_type (str or `IotHubScaleType`) – The type of the scale. Possible values include: ‘Automatic’, ‘Manual’, ‘None’

class `azure.mgmt.iothub.models.``EventHubConsumerGroupInfo`(tags=None, id=None, name=None)

  Bases: `msrest.serialization.Model`

  The properties indicating the EventHubConsumerGroupInfo.

  Parameters:

  - tags (dict) – The tags.
  - id (str) – The event hub consumer group identifier.
  - name (str) – The event hub consumer group name.

class `azure.mgmt.iothub.models.``OperationInputs`(name)

  Bases: `msrest.serialization.Model`

  OperationInputs.

  Parameters: | name (str) – The name of the iot hub.

class `azure.mgmt.iothub.models.``IotHubNameAvailabilityInfo`(name_available=None, reason=None, message=None)

  Bases: `msrest.serialization.Model`

  The properties indicating whether a given iothub name is available.

  Parameters:

  - name_available (bool) – The value which indicates whether the provided name is available.
  - reason (str or `IotHubNameUnavailabilityReason`) – The reason for unavailability. Possible values include: ‘Invalid’, ‘AlreadyExists’
  - message (str) – The message describing the detailed reason.

class `azure.mgmt.iothub.models.``ExportDevicesRequest`(export_blob_container_uri, exclude_keys)

  Bases: `msrest.serialization.Model`

  Used to provide parameters when requesting an export of all devices in the hub.

  Parameters:

  - export_blob_container_uri (str) – The export BLOB container URI.
  - exclude_keys (bool) – The value indicating whether keys should be excluded during export.

class `azure.mgmt.iothub.models.``ImportDevicesRequest`(input_blob_container_uri, output_blob_container_uri)

  Bases: `msrest.serialization.Model`

  Used to provide parameters when requesting an import of all devices in the hub.

  Parameters:

  - input_blob_container_uri (str) – The input BLOB container URI.
  - output_blob_container_uri (str) – The output BLOB container URI.

class `azure.mgmt.iothub.models.``IotHubDescriptionPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of IotHubDescription object

class `azure.mgmt.iothub.models.``IotHubSkuDescriptionPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of IotHubSkuDescription object

class `azure.mgmt.iothub.models.``strPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of str object

class `azure.mgmt.iothub.models.``JobResponsePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of JobResponse object

class `azure.mgmt.iothub.models.``IotHubQuotaMetricInfoPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of IotHubQuotaMetricInfo object

class `azure.mgmt.iothub.models.``SharedAccessSignatureAuthorizationRulePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of SharedAccessSignatureAuthorizationRule object

class `azure.mgmt.iothub.models.``AccessRights`

  Bases: `enum.Enum`

  `device_connect` = 'DeviceConnect'
  `registry_read` = 'RegistryRead'
  `registry_read_device_connect` = 'RegistryRead, DeviceConnect'
  `registry_read_registry_write` = 'RegistryRead, RegistryWrite'
  `registry_read_registry_write_device_connect` = 'RegistryRead, RegistryWrite, DeviceConnect'
  `registry_read_registry_write_service_connect` = 'RegistryRead, RegistryWrite, ServiceConnect'
  `registry_read_registry_write_service_connect_device_connect` = 'RegistryRead, RegistryWrite, ServiceConnect, DeviceConnect'
  `registry_read_service_connect` = 'RegistryRead, ServiceConnect'
  `registry_read_service_connect_device_connect` = 'RegistryRead, ServiceConnect, DeviceConnect'
  `registry_write` = 'RegistryWrite'
  `registry_write_device_connect` = 'RegistryWrite, DeviceConnect'
  `registry_write_service_connect` = 'RegistryWrite, ServiceConnect'
  `registry_write_service_connect_device_connect` = 'RegistryWrite, ServiceConnect, DeviceConnect'
  `service_connect` = 'ServiceConnect'
  `service_connect_device_connect` = 'ServiceConnect, DeviceConnect'

class `azure.mgmt.iothub.models.``SBAccessRights`

  Bases: `enum.Enum`

  `listen` = 'Listen'
  `manage` = 'Manage'
  `manage_notification_hub` = 'ManageNotificationHub'
  `send` = 'Send'

class `azure.mgmt.iothub.models.``OperationMonitoringLevel`

  Bases: `enum.Enum`

  `error` = 'Error'
  `information` = 'Information'
  `none` = 'None'

class `azure.mgmt.iothub.models.``Capabilities`

  Bases: `enum.Enum`

  `device_management` = 'DeviceManagement'
  `none` = 'None'

class `azure.mgmt.iothub.models.``IotHubSku`

  Bases: `enum.Enum`

  `f1` = 'F1'
  `s1` = 'S1'
  `s2` = 'S2'
  `s3` = 'S3'

class `azure.mgmt.iothub.models.``IotHubSkuTier`

  Bases: `enum.Enum`

  `free` = 'Free'
  `standard` = 'Standard'

class `azure.mgmt.iothub.models.``JobType`

  Bases: `enum.Enum`

  `backup` = 'backup'
  `export` = 'export'
  `factory_reset_device` = 'factoryResetDevice'
  `firmware_update` = 'firmwareUpdate'
  `import_enum` = 'import'
  `read_device_properties` = 'readDeviceProperties'
  `reboot_device` = 'rebootDevice'
  `unknown` = 'unknown'
  `update_device_configuration` = 'updateDeviceConfiguration'
  `write_device_properties` = 'writeDeviceProperties'

class `azure.mgmt.iothub.models.``JobStatus`

  Bases: `enum.Enum`

  `cancelled` = 'cancelled'
  `completed` = 'completed'
  `enqueued` = 'enqueued'
  `failed` = 'failed'
  `running` = 'running'
  `unknown` = 'unknown'

class `azure.mgmt.iothub.models.``IotHubScaleType`

  Bases: `enum.Enum`

  `automatic` = 'Automatic'
  `manual` = 'Manual'
  `none` = 'None'

class `azure.mgmt.iothub.models.``IotHubNameUnavailabilityReason`

  Bases: `enum.Enum`

  `already_exists` = 'AlreadyExists'
  `invalid` = 'Invalid'